#include "GameElements.h"

void flipX(SDL_Surface * surface)
{
    unsigned int* pixels = (unsigned int*)(surface->pixels);
    for(int y=0;y<surface->h;y++)
    {
        for(int x=0;x<surface->w>>1;x++)
        {
            int addr1=(y*surface->w + x);
            int addr2=(y*surface->w + surface->w - 1 - x);
            pixels[addr1]^=pixels[addr2];
            pixels[addr2]^=pixels[addr1];
            pixels[addr1]^=pixels[addr2];
        }
    }
}

void Object::UpdateAi()
{
    if(animState!=2)
    {
        timerCounter--;
        if(timerCounter<0)
        {
            timerCounter=rand()%150;
            switch(rand()%3)
            {
            case 0:
                animState=0;
                break;
            case 1:
                animState=1;
                break;
            case 2:
                right=!right;
                break;
            }
        }
        if(animState==0)//standing
        {
        }
        else if(animState==1)//walking
        {
            animFrame++;
            x+=(right-0.5)*3.0;
            if(x>originx+200)
            {
                right=false;
            }
            if(x<originx-200)
            {
                right=true;
            }
        }
    }
    else
    {
        animFrame++;
    }
}

void Demon::UpdateAi(bool Aggresive, double targetx,double targety)
{
    timerCounter--;
    if(aiState!=2)
    {

        if(timerCounter<0)
        {
            timerCounter=rand()%200;
            tx+=rand()%400-200;
            if(type==0 && Aggresive && (rand()&1))
            {
                aiState=1;
                tx=targetx+rand()%100-50;
                ty=targety+rand()%100-50;
            }
            else
            {
                aiState=0;
                ty=50.0+rand()%100;
            }

        }
        if(aiState==1)
        {
            if((x-tx)*(x-tx)+(y-ty)*(y-ty)<40.0*40.0)
            {
                aiState=0;
                timerCounter=200;

                ty=50.0+rand()%20;
            }
        }
    }
    dx=dx*0.99+(tx-x)*0.0001;
    dy=dy*0.99+(ty-y)*0.0001;
    x+=dx;
    y+=dy;

    right=tx>x;

    animFrame++;

}





































